<?php

namespace EventPortal\Domain\Component;

class Actions
{
    /** @var array */
    private $actions = [];

    public static function make(): self
    {
        return new self();
    }

    public function add(array $actions): self
    {
        $this->actions = array_merge($this->actions, $actions);

        return $this;
    }

    /**
     * @param mixed $value
     * @return $this
     */
    public function when($value, array $actions, ?array $defaultActions = []): self
    {
        if ($value) {
            $this->actions = array_merge($this->actions, $actions);

            return $this;
        }

        if ($defaultActions) {
            $this->actions = array_merge($this->actions, $defaultActions);
        }

        return $this;
    }

    public function get(): array
    {
        return $this->actions;
    }
}
