<?php

namespace EventPortal\Domain\Event\Enums;

use Spatie\Enum\Enum;

class EventStatus extends Enum
{
    public static function unpublished(): EventStatus
    {
        return new class() extends EventStatus {
            public function getValue(): string
            {
                return 'unpublished';
            }

            public function getName(): string
            {
                return 'Unpublished';
            }

            public function getIndex(): int
            {
                return 10;
            }
        };
    }

    // phpcs:disable PSR1.Methods.CamelCapsMethodName.NotCamelCaps
    public static function registration_open(): EventStatus
    {
        // phpcs: enable
        return new class() extends EventStatus {
            public function getValue(): string
            {
                return 'registration_open';
            }

            public function getName(): string
            {
                return 'Registration Open';
            }

            public function getIndex(): int
            {
                return 20;
            }
        };
    }

    public static function closed(): EventStatus
    {
        return new class() extends EventStatus {
            public function getValue(): string
            {
                return 'closed';
            }

            public function getName(): string
            {
                return 'Closed';
            }

            public function getIndex(): int
            {
                return 30;
            }
        };
    }

    // phpcs:disable PSR1.Methods.CamelCapsMethodName.NotCamelCaps
    public static function post_event(): EventStatus
    {
        // phpcs: enable
        return new class() extends EventStatus {
            public function getValue(): string
            {
                return 'post_event';
            }

            public function getName(): string
            {
                return 'Post Event';
            }

            public function getIndex(): int
            {
                return 40;
            }
        };
    }
}
