<?php

namespace EventPortal\Tests\Feature\Admin\Event;

use EventPortal\Domain\Event\Models\Event;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\DatabaseMigrations;
use Spatie\Snapshots\MatchesSnapshots;

class EventIndexTest extends TestCase
{
    use DatabaseMigrations, MatchesSnapshots;

    /** @test **/
    public function can_view_index()
    {
        factory(Event::class)->create(['name' => 'Hello World!']);

        $this->assertMatchesJsonSnapshot($this->get(route('admin.event.index'))->props());
    }

    /** @test **/
    public function archived_events_are_not_shown_in_listing()
    {
        factory(Event::class)->create(['name' => 'Hello World!']);
        factory(Event::class)->state('archived')->create(['name' => 'Archived Event']);

        $this->assertMatchesJsonSnapshot($this->get(route('admin.event.index'))->props());
    }
}
