<?php

namespace EventPortal\Tests\Unit\Event\Handlers;

use EventPortal\Domain\Component\Option;
use EventPortal\Domain\Event\Enums\EventStatus;
use EventPortal\Domain\Event\Handlers\SetAsUnpublished;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\User\Handlers\CreateUser;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Pipeline\Pipeline;

class SetAsUnpublishedTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function can_set_as_unpublished()
    {
        $event = factory(Event::class)->create(['status' => EventStatus::registration_open()]);

        $payload = Payload::make()->withModel($event);

        app(Pipeline::class)
            ->send($payload)
            ->through([new SetAsUnpublished])
            ->thenReturn();

        $this->assertEquals(Option::make('Unpublished')->toArray(), $event->status);
    }
}
